/*-*-compile-command:"g++ -shared -I$NTL/include -L$NTL/src/ntl.a -O2 ntlpari.c -ontl.so"-*-*/

/*Warning: If you know *anything* about C++ do not read this code.
 *I wrote it without any hint on C++.
 *You are welcome to rewrite it properly.
 *It seems to work, though.
 */
#include <gmp.h>
#include <math.h>
#include <NTL/matrix.h>
#include <NTL/mat_ZZ.h>
#include <NTL/LLL.h>
#include <NTL/lzz_pXFactoring.h>
#include <NTL/ZZ_pXFactoring.h>
#include <NTL/lzz_pEXFactoring.h>
#include <NTL/ZZ_pEXFactoring.h>
#include <NTL/ZZXFactoring.h>
#include <pari/pari.h>

#if !defined(PARI_VERSION_CODE) 
#define FpX_red Fp_pol_red
#elif PARI_VERSION_CODE < PARI_VERSION(2,2,1)
#define FpX_red Fp_pol_red
#endif

#ifndef int_W
#define int_W(x,l) ((x)+lgefint((x))-1-(l))
#endif

#undef init

/*From ntl/src/g_lip_impl.h*/

#define ALLOC(p) (((long *) (p))[0])
#define SIZE(p) (((long *) (p))[1])
#define DATA(p) ((mp_limb_t *) (((long *) (p)) + 2))



ZZ to_ZZ(GEN x)
{
  ZZ a;
  if (typ(x)!=t_INT)
    pari_err(typeer,"to_ZZ");
  long sg=signe(x);
  if (!sg) return to_ZZ(0);
  long i,l=lgefint(x)-2;
  NTL_zsetlength(&a.rep,l);
  void *rep=a.rep;
  SIZE(rep)=sg==1?l:-l;
  for(i=0;i<l;i++)
  DATA(rep)[i]=*int_W(x,i);
  return(a);
}


mat_ZZ to_mat_ZZ(GEN M) 
{
  int colonnes = lg(M) - 1, lignes = lg((GEN)M[1]) - 1, i, j; 
  mat_ZZ m = mat_ZZ(); 
  
  m.SetDims(lignes, colonnes); 
  for (i = 1; i <= lignes; i++) 
    for (j = 1; j <= colonnes; j++) 
      m(i, j) = to_ZZ(gmael(M, i, j)); 
  
  return m; 
}

ZZX to_ZZX(GEN T)
{
  ZZX P;
  vec_ZZ v;
  if (typ(T)!=t_POL)
    pari_err(typeer,"to_ZZX");
  long i,l=lgef(T);
  v.SetLength(l-2);
  for(i=2;i<l;i++)
    v[i-2]=to_ZZ((GEN)T[i]);
  P.rep=v;
  return P;
}

inline zz_p to_zz_p(GEN x) { return to_zz_p(itos(x)); }

zz_pX to_zz_pX(GEN T)
{
  zz_pX P;
  vec_zz_p v;
  if (typ(T)==t_INT)
    return to_zz_pX(itos(T));
  if (typ(T)!=t_POL)
    pari_err(typeer,"to_zz_pX");
  if (typ(T)==t_VECSMALL)
  {
    long i,l=lg(T);
    v.SetLength(l-2);
    for(i=2;i<l;i++)
      v[i-2]=T[i];
    P.rep=v;
    return P;
  }
  long i,l=lgef(T);
  v.SetLength(l-2);
  for(i=2;i<l;i++)
    v[i-2]=to_zz_p((GEN)T[i]);
  P.rep=v;
  return P;
}

inline ZZ_p to_ZZ_p(GEN x) { return to_ZZ_p(to_ZZ(x)); }

ZZ_pX to_ZZ_pX(GEN T)
{
  ZZ_pX P;
  vec_ZZ_p v;
  if (typ(T)==t_INT)
    return to_ZZ_pX(to_ZZ(T));
  if (typ(T)!=t_POL)
    pari_err(typeer,"to_ZZ_pX");
  long i,l=lgef(T);
  v.SetLength(l-2);
  for(i=2;i<l;i++)
    v[i-2]=to_ZZ_p((GEN)T[i]);
  P.rep=v;
  return P;
}

inline zz_pE to_zz_pE(GEN x) { return to_zz_pE(to_zz_pX(x)); }

zz_pEX to_zz_pEX(GEN T)
{
  zz_pEX P;
  vec_zz_pE v;
  if (typ(T)!=t_POL)
    pari_err(typeer,"to_zz_pEX");
  long i,l=lgef(T);
  v.SetLength(l-2);
  for(i=2;i<l;i++)
    v[i-2]=to_zz_pE((GEN)T[i]);
  P.rep=v;
  return P;
}

inline ZZ_pE to_ZZ_pE(GEN x) { return to_ZZ_pE(to_ZZ_pX(x)); }

ZZ_pEX to_ZZ_pEX(GEN T)
{
  ZZ_pEX P;
  vec_ZZ_pE v;
  if (typ(T)!=t_POL)
    pari_err(typeer,"to_ZZ_pEX");
  long i,l=lgef(T);
  v.SetLength(l-2);
  for(i=2;i<l;i++)
    v[i-2]=to_ZZ_pE((GEN)T[i]);
  P.rep=v;
  return P;
}

inline GEN to_GEN(long x) {return stoi(x);}

GEN to_GEN(ZZ x)
{
  void *rep=x.rep;
  if (!rep) return gzero;
  long s=SIZE(rep);
  if (!s) return gzero;
  long sg;
  if (s>0)
    sg=1;
  else
  {
    sg=-1; s=-s;
  }
  long i,l=s+2;
  unsigned long *data=DATA(rep);
  GEN z=cgetg(l,t_INT);
  z[1]=evalsigne(sg)|evallgefint(l);
  for(i=0;i<s;i++)
    *int_W(z,i)=data[i];
  return z;
}

GEN to_GEN(mat_ZZ m)
{
  int lignes = m.NumRows(), colonnes = m.NumCols(), i, j; 
  GEN M = cgetg(colonnes + 1, t_MAT);

  for (j = 1; j <= colonnes; j++) M[j] = lgetg(lignes + 1, t_COL);

  for (j = 1; j <= colonnes; j++)
    for (i = 1; i <= lignes; i++)
      mael(M, i, j) = (long)to_GEN(m(i,j)); 

  return M; 
} 

GEN to_GEN(ZZX T, long var)
{
  vec_ZZ v=T.rep;
  long i,l=v.length();
  GEN P=cgetg(l+2,t_POL);
  P[1]=evalsigne(l>0) | evallgef(l+2)|evalvarn(var);
  for(i=0;i<l;i++)
    P[i+2]=(long)to_GEN(v[i]);
  return P;
}

inline GEN to_GEN(zz_p a) { return to_GEN(rep(a)); }

GEN to_GEN(zz_pX T, long var)
{
  vec_zz_p v=T.rep;
  long i,l=v.length();
  GEN P=cgetg(l+2,t_POL);
  P[1]=evalsigne(l>0) | evallgef(l+2)|evalvarn(var);
  for(i=0;i<l;i++)
    P[i+2]= (long) to_GEN(v[i]);
  return P;
}

inline GEN to_GEN(ZZ_p a) { return to_GEN(rep(a)); }

GEN to_GEN(ZZ_pX T, long var)
{
  vec_ZZ_p v=T.rep;
  long i,l=v.length();
  GEN P=cgetg(l+2,t_POL);
  P[1]=evalsigne(l>0) | evallgef(l+2)|evalvarn(var);
  for(i=0;i<l;i++)
    P[i+2]= (long) to_GEN(v[i]);
  return P;
}

inline GEN to_GEN(zz_pE a,long w) { return to_GEN(rep(a),w); }

GEN to_GEN(zz_pEX T, long var, long w)
{
  vec_zz_pE v=T.rep;    
  long i,l=v.length();
  GEN P=cgetg(l+2,t_POL);
  P[1]=evalsigne(l>0) | evallgef(l+2)|evalvarn(var);
  for(i=0;i<l;i++)
    P[i+2]=(long) to_GEN(v[i],w);
  return P;
}

inline GEN to_GEN(ZZ_pE a,long w) { return to_GEN(rep(a),w); }

GEN to_GEN(ZZ_pEX T, long var, long w)
{
  vec_ZZ_pE v=T.rep;    
  long i,l=v.length();
  GEN P=cgetg(l+2,t_POL);
  P[1]=evalsigne(l>0) | evallgef(l+2)|evalvarn(var);
  for(i=0;i<l;i++)
    P[i+2]=(long) to_GEN(v[i],w);
  return P;
}

GEN to_GEN(vec_pair_ZZX_long factors, long v)
{
  long i,l=1+factors.length();
  GEN z=cgetg(3,t_MAT);
  z[1]=lgetg(l,t_COL);
  z[2]=lgetg(l,t_COL);
  for(i=1;i<l;i++)
  {
    mael(z,1,i)=(long) to_GEN(factors(i).a,v);
    mael(z,2,i)=(long) to_GEN(factors(i).b);
  }
  return z;
}

GEN to_GEN(vec_pair_zz_pX_long factors, long v)
{
  long i,l=1+factors.length();
  GEN z=cgetg(3,t_MAT);
  z[1]=lgetg(l,t_COL);
  z[2]=lgetg(l,t_COL);
  for(i=1;i<l;i++)
  {
    mael(z,1,i)=(long) to_GEN(factors(i).a,v);
    mael(z,2,i)=(long) to_GEN(factors(i).b);
  }
  return z;
}

GEN to_GEN(vec_pair_ZZ_pX_long factors, long v)
{
  long i,l=1+factors.length();
  GEN z=cgetg(3,t_MAT);
  z[1]=lgetg(l,t_COL);
  z[2]=lgetg(l,t_COL);
  for(i=1;i<l;i++)
  {
    mael(z,1,i)=(long) to_GEN(factors(i).a,v);
    mael(z,2,i)=(long) to_GEN(factors(i).b);
  }
  return z;
}

GEN to_GEN(vec_pair_zz_pEX_long factors, long v, long w)
{
  long i,l=1+factors.length();
  GEN z=cgetg(3,t_MAT);
  z[1]=lgetg(l,t_COL);
  z[2]=lgetg(l,t_COL);
  for(i=1;i<l;i++)
  {
    mael(z,1,i)=(long) to_GEN(factors(i).a,v,w);
    mael(z,2,i)=(long) to_GEN(factors(i).b);
  }
  return z;
}

GEN to_GEN(vec_pair_ZZ_pEX_long factors, long v, long w)
{
  long i,l=1+factors.length();
  GEN z=cgetg(3,t_MAT);
  z[1]=lgetg(l,t_COL);
  z[2]=lgetg(l,t_COL);
  for(i=1;i<l;i++)
  {
    mael(z,1,i)=(long) to_GEN(factors(i).a,v,w);
    mael(z,2,i)=(long) to_GEN(factors(i).b);
  }
  return z;
}


extern "C" 
{ 
  long prime_is_NTL_small(GEN x)
  {
    if (typ(x)!=t_INT) pari_err(typeer,"prime_is_NTL_small");
    if (!signe(x)) pari_err(talker,"0 is not a prime number in prime_is_NTL_small");
    if (lgef(x)!=3)
      return 0;
    if ( (ulong)(x[2]) < NTL_SP_BOUND )
      return x[2];
    return 0;
  }
  void pari_ntl_error(char *s)
  {
    pari_err(talker,"NTL: %s",s);
  }
  extern void (*ntl_error_hook)(char *s);
  void init_ntl(void)
  {
    ntl_error_hook=&pari_ntl_error;
  }
  GEN ntlfactormod(GEN T, GEN p)
  {
    int zp=prime_is_NTL_small(p);
    if (zp)
    {
      ulong ltop=avma;
      zz_p::init(zp);
      zz_pX P=to_zz_pX(FpX_red(T,p));
      vec_pair_zz_pX_long factors=berlekamp(P,DEBUGLEVEL>=2);
      avma=ltop;
      return to_GEN(factors,varn(T));
    }
    else
    {
      ZZ_p::init(to_ZZ(p));
      ZZ_pX P=to_ZZ_pX(T);
      vec_pair_ZZ_pX_long factors=berlekamp(P,DEBUGLEVEL>=2);
      return to_GEN(factors,varn(T));
    }
  }
  
  GEN ntlfactorcantor(GEN T, GEN p)
  {
    int zp=prime_is_NTL_small(p);
    if (zp)
    {
      ulong ltop=avma;
      zz_p::init(zp);
      zz_pX P=to_zz_pX(FpX_red(T,p));
      vec_pair_zz_pX_long factors=CanZass(P,DEBUGLEVEL>=2);
      return gerepileupto(ltop,to_GEN(factors,varn(T)));
    }
    else
    {
      ZZ_p::init(to_ZZ(p));
      ZZ_pX P=to_ZZ_pX(T);
      vec_pair_ZZ_pX_long factors=CanZass(P,DEBUGLEVEL>=2);
      return to_GEN(factors,varn(T));
    }
  }

  GEN ntlsimplefactmod(GEN T, long p)
  {
    long i,l;
    vec_pair_zz_pX_long factors;
    zz_pX  h;
    zz_p::init(p);
    zz_pX P=to_zz_pX(T);
    SFCanZass1(factors,h,P,0);
    l=1+factors.length();
    GEN z=cgetg(3,t_MAT);
    z[1]=lgetg(l,t_COL);
    z[2]=lgetg(l,t_COL);
    for(i=1;i<l;i++)
    {
      mael(z,1,i)=lstoi(factors(i).b);
      mael(z,2,i)=lstoi(deg(factors(i).a)/factors(i).b);
    }
    return z;
  }
#if 0
  GEN ntlfactorff(GEN GT, GEN p, GEN GP)
  {
    int zp=prime_is_NTL_small(p);
    if (zp)
    {
      zz_p::init(zp);
      zz_pX P=to_zz_pX(GP);
      zz_pE::init(P);
      zz_pEX T=to_zz_pEX(GT);
      long v=varn(GT),w=varn(GP);
      vec_pair_zz_pEX_long factors = berlekamp(T,DEBUGLEVEL>=2);
      return to_GEN(factors,v,w);
    }
    else
    {
      ZZ_p::init(to_ZZ(p));
      ZZ_pX P=to_ZZ_pX(GP);
      ZZ_pE::init(P);
      ZZ_pEX T=to_ZZ_pEX(GT);
      long v=varn(GT),w=varn(GP);
      vec_pair_ZZ_pEX_long  factors = berlekamp(T,DEBUGLEVEL>=2);
      return to_GEN(factors,v,w);
    }
  }
#endif
  GEN ntlfactorff(GEN GT, GEN p, GEN GP)
  {
    int zp=prime_is_NTL_small(p);
    if (zp)
    {
      zz_p::init(zp);
      zz_pX P=to_zz_pX(GP);
      zz_pE::init(P);
      zz_pEX T=to_zz_pEX(GT);
      long v=varn(GT),w=varn(GP);
      vec_pair_zz_pEX_long  factors = CanZass(T,DEBUGLEVEL>=2);
      return to_GEN(factors,v,w);
    }
    else
    {
      ZZ_p::init(to_ZZ(p));
      ZZ_pX P=to_ZZ_pX(GP);
      ZZ_pE::init(P);
      ZZ_pEX T=to_ZZ_pEX(GT);
      long v=varn(GT),w=varn(GP);
      vec_pair_ZZ_pEX_long  factors = CanZass(T,DEBUGLEVEL>=2);
      return to_GEN(factors,v,w);
    }
  }

  GEN ntlpolrootsff(GEN GT, GEN p, GEN GP)
  {
    int zp=prime_is_NTL_small(p);
    if (zp)
    {
      zz_p::init(zp);
      zz_pX P=to_zz_pX(GP);
      zz_pE::init(P);
      zz_pEX T=to_zz_pEX(GT);
      zz_pE root = FindRoot(T);
      return to_GEN(root,varn(GP));
    }
    else
    {
      ZZ_p::init(to_ZZ(p));
      ZZ_pX P=to_ZZ_pX(GP);
      ZZ_pE::init(P);
      ZZ_pEX T=to_ZZ_pEX(GT);
      ZZ_pE root = FindRoot(T);
      return to_GEN(root,varn(GP));
    }
  }

  GEN ntlffinit(GEN p, long n, long v)
  {
    int zp=prime_is_NTL_small(p);
    if (zp)
    {
      zz_p::init(zp);
      zz_pX f=BuildIrred_zz_pX(n);
      return to_GEN(f,v==-1?0:v);
    }
    else
    {
      ZZ_p::init(to_ZZ(p));
      ZZ_pX f=BuildIrred_ZZ_pX(n);
      return to_GEN(f,v==-1?0:v);
    }
  }

  GEN ntlfactor(GEN P, long bnd)
  {
    ZZ c;
    vec_pair_ZZX_long factors;
    ZZX f = to_ZZX(P);
    long v=varn(P);
    factor(c,factors,f,DEBUGLEVEL>=2,bnd);
    return to_GEN(factors,v);
  }

  GEN ntlfactorial(long n)
  {
    ZZ c=to_ZZ(1);
    long i;
    for(i=2;i<=n;i++)
      c*=i;
    return to_GEN(c);
  }
  GEN ntlbench(GEN GP, GEN GT, long p, long iter)
  {
      zz_p::init(p);
      zz_pX P=to_zz_pX(GP);
      zz_pE::init(P);
      zz_pE T=to_zz_pE(GT);
      zz_pE Z=to_zz_pE(1);
      for(int i=1; i<=iter; i++)
      {
        mul(Z,Z,T);
      }
      return to_GEN(Z,varn(GT));
  }
  GEN ntlbenchsqr(GEN GP, GEN GT, long p, long iter)
  {
      zz_p::init(p);
      zz_pX P=to_zz_pX(GP);
      zz_pE::init(P);
      zz_pE T=to_zz_pE(GT);
      zz_pE Z=T;
      for(int i=1; i<=iter; i++)
      {
        mul(Z,Z,Z);
      }
      return to_GEN(Z,varn(GT));
  }
  GEN Flx_ntlsqr(GEN GP, long p)
  {
     zz_p::init(p);
     zz_pX Z=to_zz_pX(GP);
     mul(Z,Z,Z);
     return to_GEN(Z,varn(GP));
  }

  GEN ntllllint(GEN M) 
  {
    mat_ZZ U = mat_ZZ(), B = to_mat_ZZ(M); 
    ZZ det; 

    U.SetDims(B.NumRows(), B.NumCols()); 
    LLL(det, B, U, 99, 100); 

    return to_GEN(U); 
  }
  
  GEN ntllllfloat_GF(GEN M) 
  {
    mat_ZZ U = mat_ZZ(), B = to_mat_ZZ(M); 
    ZZ det; 

    U.SetDims(B.NumRows(), B.NumCols()); 
    G_LLL_FP(B, U, 0.99, 0, 0, 0); 

    return to_GEN(U); 
  }

  GEN ntllllfloat_F(GEN M) 
  {
    mat_ZZ U = mat_ZZ(), B = to_mat_ZZ(M); 
    ZZ det; 

    U.SetDims(B.NumRows(), B.NumCols()); 
    LLL_FP(B, U, 0.99, 0, 0, 0); 

    return to_GEN(U); 
  }

  GEN ntllllfloat_GX(GEN M) 
  {
    mat_ZZ U = mat_ZZ(), B = to_mat_ZZ(M); 
    ZZ det; 

    U.SetDims(B.NumRows(), B.NumCols()); 
    G_LLL_XD(B, U, 0.99, 0, 0, 0); 

    return to_GEN(U); 
  }

  GEN ntllllfloat_X(GEN M) 
  {
    mat_ZZ U = mat_ZZ(), B = to_mat_ZZ(M); 
    ZZ det; 

    U.SetDims(B.NumRows(), B.NumCols()); 
    LLL_XD(B, U, 0.99, 0, 0, 0); 

    return to_GEN(U); 
  }
}
